<?php
declare(strict_types = 1);
namespace app\common\event;

use app\common\model\LogUser;

class User
{
    //  处理登录事件
    public function Log($data, $event_name)
    {
        $_fun = explode('.',$event_name);
        $_fun = end($_fun);
        if(!method_exists($this,$_fun)){
            return true;
        }
        return $this->$_fun($data);
    }
    //  登录成功
    protected function Success($data)
    {
        $this->SetUserData($data);
        $this->SetUserLog($data);
        return true;
    }
    //  保存用户缓存
    protected function SetUserData($data){
        $session = request()->session();
        $session->set('userdb', $data);
        if(request()->viewconf['app'] == 'admin'){
            $session->set('_eru_', $data);
        }
    }
    //  记录登录日志
    protected function SetUserLog($data,$error = false){
        $_name = empty($data['u_name']) ? $data['u_phone'] : $data['u_name'];
        $_pwd = $data['u_password'] ?? '';
        $_pwd = empty($data['u_code']) ? $_pwd : $data['u_code'];
        $_add = [
            'uid' => $error ? '' : $data['uid'],
            'type' => request()->app,
            'title' =>  $error ? '用户登录失败' : '用户登录成功',
            'cont' => $error ? "用户名: {$_name}, 密码： {$_pwd}" : '密码已加密',
        ];
        $_m = new LogUser();
        $_add = $_m->EditAdd($_add);
        $_m->SetOne($_add);
        return true;
    }
    //  退出登录
    protected function OutUser(){
        $session = request()->session();
        $session->delete('userdb');
        if(request()->viewconf['app'] == 'admin'){
            $session->delete('_eru_');
        }
        return true;
    }


}